%{
#include "gtkzip.h" 
  gint i=0;
%}

ws [ \t]+
nl \n            

%x MNT_PT_FIRST
%x MNT_PT_REST
%x MNT_DEV
%x SCROLL_MESG_TIMEOUT
%x MESG_TIMEOUT

%%

{ws}*{nl} {} /* white space */
#.* {}       /* comments */

	/**************************************************/
	/* load_options()                                 */
	/**************************************************/

Zip_Mount_Point{ws}*:{ws}* { 
  BEGIN MNT_PT_FIRST; }
<MNT_PT_FIRST>{nl} { g_print("Skindata file wrong format!\n"); BEGIN 0; }
<MNT_PT_FIRST>[^ \t\n\/] {
  mnt_dir = g_strdup(yytext);
  BEGIN MNT_PT_REST;
}
<MNT_PT_FIRST>[\/]+ {
  mnt_dir = g_strdup("/");
  BEGIN MNT_PT_REST;
}
<MNT_PT_REST>{nl} { 
  BEGIN 0; i=0; 
}
<MNT_PT_REST>[^ \/\t\n]*[\/]* { 
  mnt_dirs[i] = g_strconcat(mnt_dir, yytext, NULL);
  mnt_dir = g_strdup(mnt_dirs[i++]);
}

Zip_Device{ws}*:{ws}* { BEGIN MNT_DEV; }
<MNT_DEV>[^ \t\n]+ {
  dev = g_strdup(yytext);
  BEGIN 0;
}

Scroll_Mesg_Timeout{ws}*:{ws}* { BEGIN SCROLL_MESG_TIMEOUT; }
<SCROLL_MESG_TIMEOUT>[0-9]+ {
  scroll_msg_timeout = atoi(yytext);
}
<SCROLL_MESG_TIMEOUT>{nl} { BEGIN 0; }
<SCROLL_MESG_TIMEOUT>[^ 0-9\n]+ { 
  g_print("Skindata file wrong format!\n"); BEGIN 0; }

Mesg_Timeout{ws}*:{ws}* { BEGIN MESG_TIMEOUT; } 
<MESG_TIMEOUT>[0-9]+ {
  msg_timeout = atoi(yytext);
}
<MESG_TIMEOUT>{nl} { BEGIN 0; }
<MESG_TIMEOUT>[^ 0-9\n]+ { g_print("Skindata file wrong format!\n"); BEGIN 0; }


	/**************************************************/
	/* end -- load_options()                          */
	/**************************************************/						  
. {}

%%
 

    
